<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<!--
Copyright &copy; 2007, 2011 Oracle and/or its affiliates. All rights reserved.
 -->
<html>
  <head>
    <meta content="text/html; charset=UTF-8" http-equiv="content-type">
    <link rel="StyleSheet" type="text/css" href="/org/netbeans/modules/usersguide/ide.css">
     
    <title>C/C++/Fortran Projects and Makefiles</title>
  </head>
  <body>
    <h2>
       C/C++/Fortran Projects and Makefiles
    </h2>
    <p>
       <small><a href="#seealso">See Also</a>&nbsp;</small>
    </p>
    <p>
       Before you begin developing C, C++, or Fortran applications in the IDE, you should be
      familiar with the following concepts:
    </p>
    <ul>
      <li>
        <a href="#projects">Projects</a>
      </li>
      <li>
        <a href="#makefiles">Makefiles</a>
      </li>
    </ul>
    <h3>
       Projects<a name="projects"></a>
    </h3>
    <p>
       A C or C++ or Fortran project is a group of source files and associated information about
      how to compile and link the source files and run the resulting program. The IDE stores
      project information in a project folder that includes a makefile and metadata files. Your
      source directories do not need to be physically located in the project folder.
    </p>
    <p>
       In the IDE, you always work inside a project even if your program is contained in a single
      source file. Each project must have a makefile so the IDE can build the project. A project's
      makefile can be generated by the IDE or you can use a makefile that was previously created
      outside the IDE. Projects with IDE-generated makefiles are called managed projects.
    </p>
    <p>
       You can also create projects from existing sources that already include a makefile, or that
      build a makefile when you run <tt>configure</tt> scripts. This type of project is called an
      unmanaged project.
    </p>
    <p>
       You work with projects through the IDE's Projects window. See <a href=
      "IDEToolsCandC++Development.html#Projects">IDE Tools for C and C++ Development</a> for more
      information.
    </p>
    <h3>
       Makefiles<a name="makefiles"></a>
    </h3>
    <p>
       A makefile is a file of shell commands that the <tt>make</tt> utility uses. The
      <tt>make</tt> utility is a program that is provided independently of the IDE, often with the
      tool collection along with the compilers. Typically, the <tt>make</tt> utility uses the
      makefile to determine which portions of a program to compile, but there are other uses also.
    </p>
    <p>
       The C and C++ project system is built directly on top of the <tt>make</tt> utility. All of
      the project commands, like Build or Run, run <tt>make</tt> to call targets in the project's
      makefile. You can therefore build and run your C, C++, or Fortran project outside the IDE by
      running <tt>make</tt>, the same way the IDE builds and runs your project.
    </p>
    <p>
       You do not need to know the <tt>make</tt> utility to work with the IDE. For a managed C/C++
      Application, Dynamic Library, or Static Library project, you can set all the basic
      compilation and runtime options in the project's Project Properties dialog box and the IDE
      automatically updates your project's makefile. If you know how to work with makefiles, you
      can customize a project's makefile or write your own makefile for your project. You can also
      <a href="../CreatingMakefile/CreatingMakefile.html">create a makefile with the Makefile
      wizard</a> in the IDE.
    </p>
    <p>
       An unmanaged project with an existing makefile might use a <tt>configure</tt> script.
      Configure scripts detect information about the system on which you are running, and use the
      information to generate a makefile that is tailored to the system.
    </p>
    <p>
       For an unmanaged project, the makefile is not updated when you set project properties in the
      IDE. To change a makefile that was created outside the IDE, you must edit the makefile
      manually or run a script to recreate the makefile.
    </p>
    <p>
       If an unmanaged project has a configure script, a qmake <tt>*.pro</tt> script, or
      <tt>CMakeLists.txt</tt> script, the script is run during project creation to create the
      makefile. After the project is created, if you need to change the makefile, you can rerun the
      project's script from the command line. If you prefer to work within the IDE, you can
      reconfigure the project by right-clicking the project node and selecting Code Assistance &gt;
      Reconfigure Project... The IDE will run the project's script to regenerate the makefile, and
      do a clean build of the project.
    </p>
    <p>
       If the project is a qmake or cmake project, you can edit the <tt>*.pro</tt> or
      <tt>CMakeLists.txt</tt> file before reconfiguring if you want.
    </p>
<table>
      <tr>
        <th align="left" colspan="2">
          <a name="seealso">See also</a> 
        </th>
      </tr>
      <tr>
        <td>
        <a href="IDEToolsCandC++Development.html#Projects">IDE Tools for C and C++
      Development</a><br>
        <a href="../WorkingWithCandC++Projects/AboutCandC++Projects.html">About C and C++
      Projects</a><br>
        <a href="../CreatingMakefile/CreatingMakefile.html">Creating a Makefile</a>
        </td>
      </tr>
    </table>
    <hr>
    <p>
       <small><a href="../credits.html">Legal Notices</a></small>
    </p>
    <table cellpadding="20" border="0">
      <tr>
        <td>
          &nbsp;
        </td>
      </tr>
      <tr>
        <td>
          &nbsp;
        </td>
      </tr>
      <tr>
        <td>
          &nbsp;
        </td>
      </tr>
    </table>
  </body>
</html>
